<?php

namespace Lc\ShopBundle\Model;

use Doctrine\ORM\Mapping as ORM;
use Doctrine\Common\Collections\ArrayCollection;
use Doctrine\Common\Collections\Collection;
use Lc\ShopBundle\Context\FilterMerchantInterface;


/**
 * @ORM\MappedSuperclass()
 */
abstract class GroupUser extends AbstractDocumentEntity implements FilterMerchantInterface
{

        /**
         * @ORM\ManyToOne(targetEntity="Lc\ShopBundle\Context\MerchantInterface", inversedBy="groupUsers")
         * @ORM\JoinColumn(nullable=false)
         */
        protected $merchant;

        /**
         * @ORM\ManyToMany(targetEntity="Lc\ShopBundle\Context\UserInterface", mappedBy="groupUsers")
         */
        protected $users;


        public function __toString()
        {
                return $this->getTitle();
        }


        public function __construct()
        {
            $this->users = new ArrayCollection();
        }

        public function getMerchant(): ?Merchant
        {
                return $this->merchant;
        }

        public function setMerchant(?Merchant $merchant): self
        {
                $this->merchant = $merchant;

                return $this;
        }

        /**
         * @return Collection|User[]
         */
        public function getUsers(): Collection
        {
            return $this->users;
        }

        public function addUser(User $user): self
        {
            if (!$this->users->contains($user)) {
                $this->users[] = $user;
            }

            return $this;
        }

        public function removeUser(User $user): self
        {
            if ($this->users->contains($user)) {
                $this->users->removeElement($user);
            }

            return $this;
        }


}
